#!/bin/python
# -*- coding: utf8 -*-

"""Just show the phrases nicer."""

from __future__ import with_statement

import codecs
import os
import sys
import textwrap
import time


BASE_TEMPLATE = u"""
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />

<Title>Facundario 2.71 Enterprise Edition (Extra Apulentado)</title>

</head>
<body>
<div class="heading">
    <h2>Bienvenido al Facundario 2.71 Enterprise Edition</h2>
    <h3>(version extra apulentada)</h3>
</div>
<div class="history">
    <div class="facundopic">
    <img id="batistapic1" src="batistaflash_mini.jpg" /> <img id="batistapic2" src="batistaflash.jpg" /> <img id="batistapic3" src="batistaflash_2.jpg" />
    <p>Cuenta la historia que alla por el año 2007 el canal de irc de PyAr. estaba en decaida.
    La gente no lo visitaba y nadie sabía de su existencia hasta que facundobatista decidió aparecer
    e iluminar a los integrantes de PyAr con el conocimiento del canal (o sea los cagó a pedos para que entren).
    Una vez en el canal, decidió impartir su sabiduría, este texto contiene algunas de las mas profundas frases que nos dejó </p>
    <p>Ahora, los nuevos items son automáticamente extraídos del timeline de twitter/identi.ca, :)</p>
    <p>La información de qué son esas tres fotos, y en qué contextos fueron tomadas, será sólo entregada por perrito666 a cambio de cerveza.</p>
    </div>
</div>
<div class="facufrases">
<ul>
%s
</ul>
</div>
<br/><img src="./python-powered-w-100x40.png" alt="Python Powered" /><br><small><i>Página generada en %.2f segs</i></small>
</body>
</html>
"""


def getFrases(nomarch):
    with codecs.open(nomarch, "r", "utf8") as fh:
        lineas = sorted(fh.readlines(), reverse=True)
    return [l.split(" ", 2) for l in lineas]

def getCookies(frases):
    content = []
    for (date, hour, words) in getFrases(frases):
        content.extend(textwrap.wrap(words, 72))
        tstamp = time.strptime(date, "%Y-%m-%d")
        firma = "        -- Facundo Batista, %s" % (time.strftime("%b %d, %Y", tstamp),)
        content.append(firma)
        content.append('%%')

    # remove last separator
    content = content[:-1]
    return "\n".join(content)

def getHtml(frases):
    tant = time.time()
    content = []
    dateant = None
    for (date, hour, words) in getFrases(frases):
        if dateant != date:
            content.append("<li> %s" % date)
        content.append("<ul><li>")
        content.append('  <span class="hour">(%s)</span><span class="epic_words"> %s</span>' % (hour, words))
        content.append("</li></ul>")
        if dateant != date:
            content.append("</li>")
            dateant = date
    pag = BASE_TEMPLATE % ("".join(content), time.time() - tant)
    return pag.encode("utf-8")


def index(environ, start_response):
    status = '200 OK'
    response_headers = [('Content-type','text/html')]
    start_response(status, response_headers)
    html = getHtml("/var/www/facundario/frases.txt")
    return [html]

def cookie(environ, start_response):
    status = '200 OK'
    response_headers = [('Content-type','text/plain; charset=utf-8')]
    start_response(status, response_headers)
    text = getCookies("/var/www/facundario/frases.txt")
    return [text.encode("utf8")]
